#include "dcdialog.ch"
#include "dctree.ch"
#include "dcmsg.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "nls.ch"
#include "dll.ch"

#define COLOR_BUTTONS_FG            GraMakeRGBColor( {   0,   0,   0 } )
#define COLOR_BUTTONS_BG            GraMakeRGBColor( { 165, 195, 243 } )
#define COLOR_BUTTONS_FG_MOUSEOVER  GraMakeRGBColor( {   0,   0,   0 } )
#define COLOR_BUTTONS_BG_MOUSEOVER  GraMakeRGBColor( { 248, 186, 104 } )
#define COLOR_BUTTONS_BORDER        GraMakeRGBColor( {  80,  80,  80 } )
#define COLOR_TITLE_FG              GraMakeRGBColor( { 255, 255, 255 } )
#define COLOR_TITLE_BG              GraMakeRGBColor( {  78, 113, 255 } )
#define COLOR_INFO_FG               GraMakeRGBColor( {  80,  80,  80 } )
#define COLOR_ALERT_FG              GraMakeRGBColor( {   0,  70, 255 } )
#define COLOR_ALERT_BG              GraMakeRGBColor( { 250, 240, 160 } )
#define COLOR_RECTPBUTTON           GraMakeRGBColor( { 185, 220, 250 } )
#define COLOR_SAY_SEEK              GraMakeRGBColor( { 230,  50,   0 } )
#define COLOR_BROWSELIST            GraMakeRGBColor( { 160, 170, 190 } )
#define FONT_TREEMENU   "10.Arial.Narrow"
#define FONT_BUTTONS    "11.Alaska Crt"
#define FONT_TITLE      "12.Arial"
#define FONT_INFO       "10.Arial.Narrow"
#define FONT_ALERT      "12.Arial"
#define MAX_BUTTONS     4
#define FONT_SAY        "12.Arial.Narrow"
#define FONT_GET        "12.Alaska Crt"
#define FONT_ROWSPACE  22


procedure main
SET CHARSET TO OEM
SET CONFIRM ON
SET DELETE ON
SET SCORE OFF

    DO EXAMPLE

return


PROC appsys ; RETURN




PROCEDURE EXAMPLE
LOCAL aPos:={0,0},aSize:={0,0}
LOCAL GetOptions ,GetList:={}
LOCAL oButton,oColumn

PRIVATE oDialog,oDarea,nLastState:=0
PRIVATE oBrowse,lStatus
PRIVATE nLevel,oButtonRect0
PRIVATE cCognome,cNome
cGet1:=cGet2:=SPACE(20)

aSize:={ 900,500 }
aPos[1]:=10
aPos[2]:=100


USE ("TEST.DBF") ALIAS DBTEST NEW
dbgotop()

nLevel:=0
@  2,2 DCSAY "Get1 " GET cGet1 GETID "GET1" ;
                     WHEN {||nLevel==0}

@  2,40 DCSAY "Get2 " GET cGet2 ;
                      WHEN {||nLevel==0}

@  3,2 DCBROWSE oBrowse SIZE 120,17 ID "BROWSE" ;
                WHEN {||nLevel==0} ;
                CURSORMODE XBPBRW_CURSOR_ROW ALIAS "DBTEST" ;
                PRESENTATION { { XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },      ;   /// Header FG Color
                            { XBP_PP_COL_HA_BGCLR, GRA_CLR_BACKGROUND }, ;   /// Header BG Color
                            { XBP_PP_COL_FA_FGCLR, GRA_CLR_YELLOW },     ;   /// Footer FG Color
                            { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },   ;   /// Footer BG Color
                            { XBP_PP_COL_DA_CELLHEIGHT, 20 }}            ;   /// Cell Height
                NOSIZECOLS

    DCBROWSECOL FIELD DBTEST->FIELD_1 Header "first field"   WIDTH 15 PARENT oBrowse OBJECT oColumn
    DCBROWSECOL FIELD DBTEST->FIELD_2 Header "second field"  WIDTH 10 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->FIELD_3 Header "third"         WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->FIELD_4 Header "four"          WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->FIELD_2 Header "..."           WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->FIELD_3 Header "..."           WIDTH  8 PARENT oBrowse

DCHOTKEY xbeK_ESC ACTION {|o| IIF(nLevel==0,DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList),nil)}


/* ---- PUSHBUTTON ---- */
@ aSize[2]-40,15 DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT SIZE aSize[1]-15,40 OBJECT oButtonRect0 PIXEL ;
                          COLOR COLOR_RECTPBUTTON,COLOR_RECTPBUTTON

    @ 0.2,1 DCPUSHBUTTON CAPTION "LEVEL 1"  OBJECT oButton ;
                        WHEN {||nLevel==0} ;
                        ACTION {|| TEST_LEVEL1() } SIZE 15,1.5 ;
                        PARENT oButtonRect0 TABSTOP

    @ 0.2,25 DCPUSHBUTTON CAPTION "QUIT (ESC)"  OBJECT oButton ;
                        WHEN {||nLevel==0} ;
                        ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList) } SIZE 15,1.5 ;
                        PARENT oButtonRect0 TABSTOP


DCGETOPTIONS NOBUSY CONFIRM NOESCAPEKEY ;
             ROWSPACE (FONT_ROWSPACE)  SAYFONT (FONT_SAY)  GETFONT (FONT_GET) ;
             MINSIZE aSize[1],aSize[2] MAXSIZE aSize[1],aSize[2] ;
             TITLE "DEMO" ;
             BORDER XBPDLG_DLGBORDER ;
             CLOSEQUERY MSG {||.F.} ;
             HIDE

DCREAD GUI OPTIONS GetOptions PARENT @oDialog   MULTILISTS   ;
       SETFOCUS "GET1" FIT EVAL {||oDialog:setPos( { aPos[1], aPos[2] }), oDialog:show() }


RETURN





STATIC FUNCTION TEST_LEVEL1
LOCAL GetOptions,GetList:={}
LOCAL aSize,aPos,nColPos,nRowPos,oColumn,oColumn2,oCell,aRect,nHeadHeight,nRowHeight
LOCAL nT,nX,nY,oBarEdit,oDialogNew
LOCAL oRectangle,oButtonRect1
LOCAL cVar1,cVar2,oFocus

oDarea:=oDialog:drawingArea

    nLevel:=1

    @ 12,30 DCSTATIC TYPE XBPDLG_RAISEDBORDERTHIN   SIZE 30,10 OBJECT oRectangle COLOR NIL,COLOR_TITLE_BG PARENT oDialog


    // example of two GETs
    cVar1:=SPACE(10)
    cVar2:=SPACE(15)
    @ 1,2  DCGET cVar1 GETSIZE 10 WHEN {||nLevel==1} GETID "GET1"  PARENT oRectangle
    @ 3,2  DCGET cVar2 GETSIZE 15 WHEN {||nLevel==1}               PARENT oRectangle


    /* ---- PUSHBUTTON ---- */
    @ oDialog:currentSize()[2]-50,12 DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT SIZE oButtonRect0:currentSize()[1],oButtonRect0:currentSize()[2] OBJECT oButtonRect1 PIXEL ;
                         COLOR COLOR_RECTPBUTTON,COLOR_RECTPBUTTON PARENT oDialog


        @ 0.3,1  DCPUSHBUTTON CAPTION "LEVEL 2" ;
                            WHEN {||nLevel==1} ;
                            ACTION {|| TEST_LEVEL2() } SIZE 15,1.2 PARENT oButtonRect1 TABSTOP

        @ 0.3,20 DCPUSHBUTTON CAPTION "CLOSE" ;
                            WHEN {||nLevel==1} ;
                            ACCELKEY xbeK_ESC CARGO 'CANCEL' ;
                            ACTION {|| DC_GETDESTROY(GetList),nLevel:=0,SetAppFocus( oBrowse ) } SIZE 15,1.2 PARENT oButtonRect1 TABSTOP

    DCGETOPTIONS CONFIRM

    DCREAD GUI PARENT oDialog SAVE EXIT SETFOCUS "GET1"



RETURN NIL






STATIC FUNCTION TEST_LEVEL2
LOCAL GetOptions ,GetList:={}, oDlg
LOCAL aSize,aPos,nColPos,nRowPos,oColumn,oColumn2,oCell,aRect,nHeadHeight,nRowHeight
LOCAL nT,nX,nY,oBarEdit,oDialogNew
LOCAL oRectangle,oButtonRect2
LOCAL cVar1,cVar2,oFocus

oDarea:=oDialog:drawingArea

    nLevel:=2


    @ 10,40 DCSTATIC TYPE XBPDLG_RAISEDBORDERTHIN   SIZE 50,8 OBJECT oRectangle COLOR NIL,COLOR_BUTTONS_BG_MOUSEOVER PARENT oDialog


    // example of two GETs
    cVar1:=SPACE(10)
    cVar2:=SPACE(15)
    @ 1,2  DCGET cVar1 GETSIZE 10 WHEN {||nLevel==2} GETID "GET1"  PARENT oRectangle
    @ 3,2  DCGET cVar2 GETSIZE 15 WHEN {||nLevel==2}               PARENT oRectangle


    /* ---- PUSHBUTTON ---- */
    @ oDialog:currentSize()[2]-50,12 DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT SIZE oButtonRect0:currentSize()[1],oButtonRect0:currentSize()[2] OBJECT oButtonRect2 PIXEL ;
                         COLOR COLOR_RECTPBUTTON,COLOR_RECTPBUTTON PARENT oDialog

    @ 0.3,1 DCPUSHBUTTON CAPTION "CLOSE" ;
                        WHEN {||nLevel==2} ;
                        ACCELKEY xbeK_ESC CARGO 'CANCEL' ;
                        ACTION {|| DC_GETDESTROY(GetList),nLevel:=1 } SIZE 15,1.2 PARENT oButtonRect2 TABSTOP



    DCREAD GUI PARENT oDialog  SAVE EXIT SETFOCUS "GET1"

RETURN NIL



